package dev.boyfailure.quajra.vectorbreakout;

public class Particle {
    
    byte particleID;
    short particleX;
    short particleY;
    short particleX2;
    short particleY2;
    boolean isActive = true;
    byte particleColor;
    short particleFrame = 0;
    short particleLifetime;
    float vectorScale = 1;
    byte particleDirection;
    byte particleSpeed = 2;
    
    public Particle(int particleID, int x, int y, int x2, int y2, int particleColor, float vectorScale, int direction, int speed) {
        this.particleID = (byte) particleID;
        this.particleX = (short) x;
        this.particleY = (short) y;
        this.particleX2 = (short) x2;
        this.particleY2 = (short) y2;
        this.particleColor = (byte) particleColor;
        this.vectorScale = vectorScale;
        this.particleDirection = (byte) direction;
        this.particleSpeed = (byte) speed;
    }
    
    public void spawn(int lifetime) {
        this.isActive = true;
        if (VectorBreakout.confettiMode) {this.particleLifetime = 400;}
        else {this.particleLifetime = (short) lifetime;}
    }
    
    public void update() {
        this.particleFrame++;
        if (this.particleDirection != 0) {
            switch(this.particleDirection) {
                case 1:this.particleX += this.particleSpeed;break; // Right
                case 2:this.particleX += this.particleSpeed;this.particleY+= this.particleSpeed;break; // Down right
                case 3:this.particleY += this.particleSpeed;break; // Down
                case 4:this.particleX -= this.particleSpeed;this.particleY+= this.particleSpeed;break; // Down left
                case 5:this.particleX -= this.particleSpeed;break; // Left
                case 6:this.particleX -= this.particleSpeed;this.particleY-= this.particleSpeed;break; // Up left
                case 7:this.particleY -= this.particleSpeed;break; // Up
                case 8:this.particleX += this.particleSpeed;this.particleY-= this.particleSpeed;break; // Up right
            }
        }
        if (this.particleFrame >= this.particleLifetime) {
            this.isActive = false;
        }
    }
    
}
